searchNodes=[{"doc":"Provides a set of functions to work with imglab services.","ref":"Imglab.html","title":"Imglab","type":"module"},{"doc":"Returns a formatted srcset string with the specified parameters. source must be a string indicating a source name or a Source struct . path must be a string indicating the path of the resource. params must be an optional keyword list with the image parameters to use. This function expects the same parameters and values as url/3 with the exception of some params that have a special meaning and can receive list, Range and Imglab.Sequence values. For more information about how to specify sources and paths take a look to url/3 function. Fixed size When enough information is specified about the image output size (using width or height parameters) srcset function will generate URLs with a default number of dprs: iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3 3x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=4 4x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=5 5x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=6 6x&quot; You can specify a Range value for quality parameter so you can increasingly reduce the final size of the image for big dprs: iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , quality : 80 .. 40 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=80&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=70&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=61&amp;dpr=3 3x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=53&amp;dpr=4 4x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=46&amp;dpr=5 5x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=40&amp;dpr=6 6x&quot; If you prefer a different list of dprs you can specify them as a Range or explicit list of values: iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , dpr : 1 .. 3 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3 3x&quot; iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , dpr : [ 1 , 2 , 3 ] ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3 3x&quot; And even specify Range or list values for quality param: iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , dpr : 1 .. 3 , quality : 80 .. 40 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1&amp;quality=80 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2&amp;quality=57 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3&amp;quality=40 3x&quot; iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , dpr : [ 1 , 2 , 3 ] , quality : [ 80 , 70 , 40 ] ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1&amp;quality=80 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2&amp;quality=70 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3&amp;quality=40 3x&quot; Fluid width It is possible to specify a fluid width value using Range , lists or Imglab.Sequence values: iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 300 .. 1000 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=300 300w, https://assets.imglab-cdn.net/image.jpeg?width=325 325w, https://assets.imglab-cdn.net/image.jpeg?width=352 352w, https://assets.imglab-cdn.net/image.jpeg?width=382 382w, https://assets.imglab-cdn.net/image.jpeg?width=414 414w, https://assets.imglab-cdn.net/image.jpeg?width=448 448w, https://assets.imglab-cdn.net/image.jpeg?width=486 486w, https://assets.imglab-cdn.net/image.jpeg?width=526 526w, https://assets.imglab-cdn.net/image.jpeg?width=570 570w, https://assets.imglab-cdn.net/image.jpeg?width=618 618w, https://assets.imglab-cdn.net/image.jpeg?width=669 669w, https://assets.imglab-cdn.net/image.jpeg?width=725 725w, https://assets.imglab-cdn.net/image.jpeg?width=786 786w, https://assets.imglab-cdn.net/image.jpeg?width=852 852w, https://assets.imglab-cdn.net/image.jpeg?width=923 923w, https://assets.imglab-cdn.net/image.jpeg?width=1000 1000w&quot; iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : [ 300 , 500 , 1000 ] ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=300 300w, https://assets.imglab-cdn.net/image.jpeg?width=500 500w, https://assets.imglab-cdn.net/image.jpeg?width=1000 1000w&quot; iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : Imglab.Sequence . sequence ( 300 , 1000 , 4 ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=300 300w, https://assets.imglab-cdn.net/image.jpeg?width=448 448w, https://assets.imglab-cdn.net/image.jpeg?width=669 669w, https://assets.imglab-cdn.net/image.jpeg?width=1000 1000w&quot; When specifying a fluid width value is also possible to specify height and quality fluid values: iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 300 .. 1000 , quality : 75 .. 60 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=300&amp;quality=75 300w, https://assets.imglab-cdn.net/image.jpeg?width=325&amp;quality=74 325w, https://assets.imglab-cdn.net/image.jpeg?width=352&amp;quality=73 352w, https://assets.imglab-cdn.net/image.jpeg?width=382&amp;quality=72 382w, https://assets.imglab-cdn.net/image.jpeg?width=414&amp;quality=71 414w, https://assets.imglab-cdn.net/image.jpeg?width=448&amp;quality=70 448w, https://assets.imglab-cdn.net/image.jpeg?width=486&amp;quality=69 486w, https://assets.imglab-cdn.net/image.jpeg?width=526&amp;quality=68 526w, https://assets.imglab-cdn.net/image.jpeg?width=570&amp;quality=67 570w, https://assets.imglab-cdn.net/image.jpeg?width=618&amp;quality=66 618w, https://assets.imglab-cdn.net/image.jpeg?width=669&amp;quality=65 669w, https://assets.imglab-cdn.net/image.jpeg?width=725&amp;quality=64 725w, https://assets.imglab-cdn.net/image.jpeg?width=786&amp;quality=63 786w, https://assets.imglab-cdn.net/image.jpeg?width=852&amp;quality=62 852w, https://assets.imglab-cdn.net/image.jpeg?width=923&amp;quality=61 923w, https://assets.imglab-cdn.net/image.jpeg?width=1000&amp;quality=60 1000w&quot; iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : [ 300 , 500 , 1000 ] , height : [ 400 , 600 , 700 ] , quality : [ 75 , 70 , 65 ] ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=300&amp;height=400&amp;quality=75 300w, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;quality=70 500w, https://assets.imglab-cdn.net/image.jpeg?width=1000&amp;height=700&amp;quality=65 1000w&quot; No size When information about the image output size is not specified a predefined sequence of widths will be used: iex&gt; Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=100 100w, https://assets.imglab-cdn.net/image.jpeg?width=134 134w, https://assets.imglab-cdn.net/image.jpeg?width=180 180w, https://assets.imglab-cdn.net/image.jpeg?width=241 241w, https://assets.imglab-cdn.net/image.jpeg?width=324 324w, https://assets.imglab-cdn.net/image.jpeg?width=434 434w, https://assets.imglab-cdn.net/image.jpeg?width=583 583w, https://assets.imglab-cdn.net/image.jpeg?width=781 781w, https://assets.imglab-cdn.net/image.jpeg?width=1048 1048w, https://assets.imglab-cdn.net/image.jpeg?width=1406 1406w, https://assets.imglab-cdn.net/image.jpeg?width=1886 1886w, https://assets.imglab-cdn.net/image.jpeg?width=2530 2530w, https://assets.imglab-cdn.net/image.jpeg?width=3394 3394w, https://assets.imglab-cdn.net/image.jpeg?width=4553 4553w, https://assets.imglab-cdn.net/image.jpeg?width=6107 6107w, https://assets.imglab-cdn.net/image.jpeg?width=8192 8192w&quot;","ref":"Imglab.html#srcset/3","title":"Imglab.srcset/3","type":"function"},{"doc":"Returns a formatted URL string with the specified parameters. source must be a string indicating a source name or a Source struct . path must be a string indicating the path of the resource. params must be an optional keyword list with the image parameters to use. Source The first parameter can be a string with the name of the source in the case that no additional settings for the source are needed: iex&gt; Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&quot; Or a Source struct created with Imglab.Source.new/2 specifying additional settings for the source if needed: iex&gt; &quot;assets&quot; iex&gt; |&gt; Imglab.Source . new ( ) iex&gt; |&gt; Imglab . url ( &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&quot; Secured sources You can specify a secure source and use it to generate signed URLs: iex&gt; &quot;assets&quot; iex&gt; |&gt; Imglab.Source . new ( secure_key : &quot;qxxKNvxRONOMklcGJBVczefrJnE=&quot; , secure_salt : &quot;e9bXw6/HIMGTWcmAYArHA5jpIAE=&quot; ) iex&gt; |&gt; Imglab . url ( &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;signature=MX0DlvzVo39-_Dh_YqPbOnrayWVabIWaSDzi-9PfGHQ&quot; The signature query string will be automatically added to the URL. Note: secure_key and secure_salt parameters are secrets that should not be added to the code. Please use environment vars or other secure method to use them in your project. Path The second parameter must be a string defining the path to the resource. iex&gt; Imglab . url ( &quot;assets&quot; , &quot;path/to/myimage.jpeg&quot; , width : 500 , height : 600 ) &quot;https://assets.imglab-cdn.net/path/to/myimage.jpeg?width=500&amp;height=600&quot; Params The third optional parameter is a keyword list with any desired imglab transformation parameter. Some imglab parameters use hyphens inside their names. You can use atoms with underscores, these will be normalized to the correct format used by imglab API. iex&gt; Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , trim : &quot;color&quot; , trim_color : &quot;orange&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;trim=color&amp;trim-color=orange&quot; Or you can define a quoted atom instead: iex&gt; Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , trim : &quot;color&quot; , &quot;trim-color&quot; : &quot;orange&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;trim=color&amp;trim-color=orange&quot; If no params are specified a URL without query params will be generated: iex&gt; Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg&quot;","ref":"Imglab.html#url/3","title":"Imglab.url/3","type":"function"},{"doc":"Provides a set of macros to specify color parameter values.","ref":"Imglab.Color.html","title":"Imglab.Color","type":"module"},{"doc":"Returns a named color as string. Useful to use a named color checking possible typos. Examples iex&gt; Imglab.Color . color ( &quot;blue&quot; ) &quot;blue&quot; iex&gt; Imglab.Color . color ( &quot;green&quot; ) &quot;green&quot; iex&gt; Imglab.Color . color ( &quot;white&quot; ) &quot;white&quot;","ref":"Imglab.Color.html#color/1","title":"Imglab.Color.color/1","type":"macro"},{"doc":"Returns a RGB color as string. Examples iex&gt; Imglab.Color . color ( 128 , 128 , 128 ) &quot;128,128,128&quot; iex&gt; Imglab.Color . color ( 255 , 128 , 50 ) &quot;255,128,50&quot; iex&gt; Imglab.Color . color ( 255 , 0 , 0 ) &quot;255,0,0&quot;","ref":"Imglab.Color.html#color/3","title":"Imglab.Color.color/3","type":"macro"},{"doc":"Returns a RGBA color as string. Examples iex&gt; Imglab.Color . color ( 128 , 128 , 128 , 128 ) &quot;128,128,128,128&quot; iex&gt; Imglab.Color . color ( 255 , 128 , 128 , 50 ) &quot;255,128,128,50&quot; iex&gt; Imglab.Color . color ( 255 , 128 , 0 , 0 ) &quot;255,128,0,0&quot;","ref":"Imglab.Color.html#color/4","title":"Imglab.Color.color/4","type":"macro"},{"doc":"Provides a set of macros to specify position parameter values.","ref":"Imglab.Position.html","title":"Imglab.Position","type":"module"},{"doc":"Returns a position as string. Examples iex&gt; Imglab.Position . position ( &quot;left&quot; ) &quot;left&quot; iex&gt; Imglab.Position . position ( &quot;bottom&quot; ) &quot;bottom&quot; iex&gt; Imglab.Position . position ( &quot;right&quot; ) &quot;right&quot;","ref":"Imglab.Position.html#position/1","title":"Imglab.Position.position/1","type":"macro"},{"doc":"Returns a position as string specified with horizontal and vertical values: iex&gt; Imglab.Position . position ( &quot;left&quot; , &quot;bottom&quot; ) &quot;left,bottom&quot; iex&gt; Imglab.Position . position ( &quot;center&quot; , &quot;middle&quot; ) &quot;center,middle&quot; iex&gt; Imglab.Position . position ( &quot;right&quot; , &quot;top&quot; ) &quot;right,top&quot; Or specified with vertical and horizontal values: iex&gt; Imglab.Position . position ( &quot;bottom&quot; , &quot;left&quot; ) &quot;bottom,left&quot; iex&gt; Imglab.Position . position ( &quot;middle&quot; , &quot;center&quot; ) &quot;middle,center&quot; iex&gt; Imglab.Position . position ( &quot;top&quot; , &quot;right&quot; ) &quot;top,right&quot;","ref":"Imglab.Position.html#position/2","title":"Imglab.Position.position/2","type":"macro"},{"doc":"Provides a set of functions to specify integer number sequences.","ref":"Imglab.Sequence.html","title":"Imglab.Sequence","type":"module"},{"doc":"Returns a geometric sequence of integer numbers inside an interval and with specific size as list. Examples iex&gt; Imglab.Sequence . sequence ( 100 , 8192 ) [ 100 , 134 , 180 , 241 , 324 , 434 , 583 , 781 , 1048 , 1406 , 1886 , 2530 , 3394 , 4553 , 6107 , 8192 ] iex&gt; Imglab.Sequence . sequence ( 100 , 8192 , 1 ) [ 100 ] iex&gt; Imglab.Sequence . sequence ( 100 , 8192 , 2 ) [ 100 , 8192 ] iex&gt; Imglab.Sequence . sequence ( 100 , 8192 , 4 ) [ 100 , 434 , 1886 , 8192 ] iex&gt; Imglab.Sequence . sequence ( 70 , 60 , 6 ) [ 70 , 68 , 66 , 64 , 62 , 60 ]","ref":"Imglab.Sequence.html#sequence/3","title":"Imglab.Sequence.sequence/3","type":"function"},{"doc":"Provides a way to define and store information about a imglab source.","ref":"Imglab.Source.html","title":"Imglab.Source","type":"module"},{"doc":"Returns a Source struct with the specified options for the source. name must be a string indicating the name of the source. Options The accepted options are: :host - a string specifying the host where the imglab server is located, only for imglab on-premises (default: &quot;imglab-cdn.net&quot; ) :https - a boolean value specifying if the source should use https or not (default: true ) :port - a :inet.port_number specifying a port where the imglab server is located, only for imglab on-premises :secure_key - a string specifying the source secure key :secure_salt - a string specifying the source secure salt :subdomains - a boolean value specifying if the source should be specified using subdomains instead of using the path, only for imglab on-premises (default: true ) Note: secure_key and secure_salt parameters are secrets that should not be added to the code. Please use environment vars or other secure method to use them in your project. Examples iex&gt; Imglab.Source . new ( &quot;assets&quot; ) % Imglab.Source { host : &quot;imglab-cdn.net&quot; , https : true , name : &quot;assets&quot; , port : nil , secure_key : nil , secure_salt : nil , subdomains : true } iex&gt; Imglab.Source . new ( &quot;assets&quot; , subdomains : false ) % Imglab.Source { host : &quot;imglab-cdn.net&quot; , https : true , name : &quot;assets&quot; , port : nil , secure_key : nil , secure_salt : nil , subdomains : false } iex&gt; Imglab.Source . new ( &quot;assets&quot; , https : false , host : &quot;imglab.net&quot; , port : 8080 ) % Imglab.Source { host : &quot;imglab.net&quot; , https : false , name : &quot;assets&quot; , port : 8080 , secure_key : nil , secure_salt : nil , subdomains : true } iex&gt; Imglab.Source . new ( &quot;assets&quot; , secure_key : &quot;secure-key&quot; , secure_salt : &quot;secure-salt&quot; ) % Imglab.Source { host : &quot;imglab-cdn.net&quot; , https : true , name : &quot;assets&quot; , port : nil , secure_key : &quot;secure-key&quot; , secure_salt : &quot;secure-salt&quot; , subdomains : true }","ref":"Imglab.Source.html#new/2","title":"Imglab.Source.new/2","type":"function"},{"doc":"","ref":"Imglab.Source.html#t:t/0","title":"Imglab.Source.t/0","type":"type"},{"doc":"imglab is the official Elixir library to integrate with imglab services.","ref":"readme.html","title":"imglab","type":"extras"},{"doc":"Add imglab to your list of dependencies in mix.exs : def deps do [ { :imglab , &quot;~&gt; 0.3&quot; } ] end And run: mix deps.get","ref":"readme.html#installation","title":"imglab - Installation","type":"extras"},{"doc":"imglab has been successfully tested on the following Elixir versions: 1.14 , 1.13 , 1.12 , 1.11 , 1.10 , 1.9 , 1.8 , 1.7 , 1.6 , 1.5 , and 1.4 .","ref":"readme.html#elixir-compatibility","title":"imglab - Elixir compatibility","type":"extras"},{"doc":"You can use Imglab.url/3 function to generate imglab compatible URLs for your application. The easiest way to generate a URL is to specify the source_name , path and required parameters : Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&quot; Imglab . url ( &quot;avatars&quot; , &quot;user-01.jpeg&quot; , width : 300 , height : 300 , mode : :crop , crop : :face , format : :webp ) &quot;https://avatars.imglab-cdn.net/user-01.jpeg?width=300&amp;height=300&amp;mode=crop&amp;crop=face&amp;format=webp&quot; If some specific settings are required for the source you can use a Imglab.Source struct instead of a string source name: Imglab . url ( Imglab.Source . new ( &quot;assets&quot; ) , &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&quot; Using secure image sources For sources that require signed URLs you can specify secure_key and secure_salt attributes: &quot;assets&quot; |&gt; Imglab.Source . new ( secure_key : &quot;assets-secure-key&quot; , secure_salt : &quot;assets-secure-salt&quot; ) |&gt; Imglab . url ( &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;signature=generated-signature&quot; signature query parameter will be automatically generated and attached to the returned URL. Note: secure_key and secure_salt attributes are secrets that should not be added to a code repository. Please use environment vars or other secure method to use them in your application. Using HTTP instead of HTTPS In the case that HTTP schema is required instead of HTTPS you can set https attribute to false when creating the source: &quot;assets&quot; |&gt; Imglab.Source . new ( https : false ) |&gt; Imglab . url ( &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;http://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&quot; Note: HTTPS is the default and recommended way to generate URLs with imglab. Specifying parameters Any parameter from the imglab API can be used to generate URLs with Imglab.url/3 function. For parameters that required dashes characters like trim-color you can use regular underscore Elixir atoms like :trim_color those will be normalized in the URL generation to it's correct form: Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , trim : &quot;color&quot; , trim_color : &quot;black&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?trim=color&amp;trim-color=black&quot; It is possible to use quoted atoms too: Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , trim : &quot;color&quot; , &quot;trim-color&quot; : &quot;black&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?trim=color&amp;trim-color=black&quot; Specifying color parameters Some imglab parameters can receive a color as value. It is possible to specify these color values as strings: # Specifying a RGB color as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : :contain , background_color : &quot;255,0,0&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=255%2C0%2C0&quot; # Specifying a RGBA color as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : :contain , background_color : &quot;255,0,0,128&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=255%2C0%2C0%2C128&quot; # Specifying a named color as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : :contain , background_color : &quot;red&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=red&quot; # Specifying a hexadecimal color as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : :contain , background_color : &quot;F00&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=F00&quot; You can additionally use Imglab.Color macros to specify these color values: # Remember to import Imglab.Color before use these macros import Imglab.Color # Using color macro for a RGB color Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : &quot;contain&quot; , background_color : color ( 255 , 0 , 0 ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=255%2C0%2C0&quot; # Using color macro for a RGBA color Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : &quot;contain&quot; , background_color : color ( 255 , 0 , 0 , 128 ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=255%2C0%2C0%2C128&quot; # Using color macro for a named color Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : &quot;contain&quot; , background_color : color ( &quot;red&quot; ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=red&quot; Note: specify hexadecimal color values using Imglab.Color macros is not allowed. You can use strings instead. Specifying position parameters Some imglab parameters can receive a position as value. It is possible to specify these values using strings: # Specifying a horizontal and vertical position as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : &quot;left,top&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=left%2Ctop&quot; # Specifying a vertical and horizontal position as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : &quot;top,left&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=top%2Cleft&quot; # Specifying a position as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : &quot;left&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=left&quot; You can additionally use Imglab.Position macros to specify these position values: # Remember to import Imglab.Position before use these macros import Imglab.Position # Using position macro for a horizontal and vertical position Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : position ( &quot;left&quot; , &quot;top&quot; ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=left%2Ctop&quot; # Using position macro for a vertical and horizontal position Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : position ( &quot;top&quot; , &quot;left&quot; ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=top%2Cleft&quot; # Using position macro for a position Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : position ( &quot;left&quot; ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=left&quot; Specifying URL parameters Some imglab parameters can receive URLs as values. It is possible to specify these parameter values as strings. Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : &quot;logo.svg&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;watermark=logo.svg&quot; And even use parameters if required: Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : &quot;logo.svg?width=100&amp;format=png&quot; ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;watermark=logo.svg%3Fwidth%3D100%26format%3Dpng&quot; Additionally you can use nested Imglab.url/3 calls to specify these URL values: Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : Imglab . url ( &quot;assets&quot; , &quot;logo.svg&quot; , width : 100 , format : :png ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;watermark=https%3A%2F%2Fassets.imglab-cdn.net%2Flogo.svg%3Fwidth%3D100%26format%3Dpng&quot; If the resource is located in a different source we can specify it using Imglab.url/3 : Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : Imglab . url ( &quot;marketing&quot; , &quot;logo.svg&quot; , width : 100 , format : :png ) ) &quot;https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;watermark=https%3A%2F%2Fmarketing.imglab-cdn.net%2Flogo.svg%3Fwidth%3D100%26format%3Dpng&quot; Using secure sources for URLs parameter values is possible too: marketing_source = Imglab.Source . new ( &quot;marketing&quot; , secure_key : &quot;marketing-secure-key&quot; , secure_salt : &quot;marketing-secure-salt&quot; ) Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : Imglab . url ( marketing_source , &quot;logo.svg&quot; , width : 100 , format : :png ) ) signature query parameter will be automatically generated and attached to the nested URL value. Specifying URLs with expiration timestamp The expires parameter allows you to specify a UNIX timestamp in seconds after which the request is expired. If an Elixir DateTime struct is used as value to expires parameter it will be automatically converted to UNIX timestamp. In the following example, we specify an expiration time of one hour, adding 3600 seconds to the current time: expires = DateTime . add ( DateTime . utc_now ( ) , 3600 ) Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , expires : expires ) If you are using an older Elixir version without DateTime.add/4 function you can add a number of seconds after transforming to UNIX timestamp: expires = DateTime . to_unix ( DateTime . utc_now ( ) ) + 3600 Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , expires : expires ) Note: The expires parameter should be used in conjunction with secure sources. Otherwise, expires value could be tampered with.","ref":"readme.html#generating-urls","title":"imglab - Generating URLs","type":"extras"},{"doc":"For on-premises imglab server is possible to define custom sources pointing to your server location. :https - a boolean value specifying if the source should use https or not (default: true ) :host - a string specifying the host where the imglab server is located. (default: imglab-cdn.net ) :port - a :inet.port_number specifying a port where the imglab server is located. :subdomains - a boolean value specifying if the source should be specified using subdomains instead of using the path. (default: true ) If we have our on-premises imglab server at http://my-company.com:8080 with a source named images we can use the following source settings to access a logo.png image: &quot;images&quot; |&gt; Imglab.Source . new ( https : false , host : &quot;my-company.com&quot; , port : 8080 ) |&gt; Imglab . url ( &quot;logo.png&quot; , width : 300 , height : 300 , format : :png ) &quot;http://images.my-company.com:8080/logo.png?width=300&amp;height=300&amp;format=png&quot; It is possible to use secure sources too: &quot;images&quot; |&gt; Imglab.Source . new ( https : false , host : &quot;my-company.com&quot; , port : 8080 , secure_key : &quot;images-secure-key&quot; , secure_salt : &quot;images-secure-salt&quot; ) |&gt; Imglab . url ( &quot;logo.png&quot; , width : 300 , height : 300 , format : :png ) &quot;http://images.my-company.com:8080/logo.png?width=300&amp;height=300&amp;format=png&amp;signature=generated-signature&quot; Using sources with disabled subdomains In the case that your on-premises imglab server is configured to use source names as paths instead of subdomains you can set subdomains attribute to false : &quot;images&quot; |&gt; Imglab.Source . new ( https : false , host : &quot;my-company.com&quot; , port : 8080 , subdomains : false ) |&gt; Imglab . url ( &quot;logo.png&quot; , width : 300 , height : 300 , format : :png ) &quot;http://my-company.com:8080/images/logo.png?width=300&amp;height=300&amp;format=png&quot;","ref":"readme.html#generating-urls-for-on-premises-imglab-server","title":"imglab - Generating URLs for on-premises imglab server","type":"extras"},{"doc":"You can use Imglab.srcset/3 function to generate custom string values for srcset attributes, to be used for Web responsive images inside an &lt;img&gt; HTML element or picture &lt;source&gt; . This function works similarly to Imglab.url/3 , expecting the same parameters and values, except for some specific query parameters that have a special meaning and can receive Range and lists as values. To learn more about responsive images and the srcset attribute, you can take a look to the MDN article about responsive images . Fixed size When enough information is provided about the image output size (using width or height parameters), srcset function will generate URLs with a default sequence of device pixel ratios: For the following example we are specying a fixed value of 500 pixels for width parameter: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 ) Generating the following output: https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3 3x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=4 4x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=5 5x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=6 6x A very common practice consists in reducing the quality of images with high pixel density, decreasing the final file size. To achieve this you can optionally specify an Elixir Range value for quality parameter, gradually reducing the file size while increasing the image size. In this example we are specifying a fixed width value of 500 pixels and a quality interval between 80 and 40 : Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , quality : 80 .. 40 ) https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=80&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=70&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=61&amp;dpr=3 3x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=53&amp;dpr=4 4x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=46&amp;dpr=5 5x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;quality=40&amp;dpr=6 6x A custom Range value can be set for dpr parameter too, overriding the default sequence of generated dprs: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , dpr : 1 .. 4 ) https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3 3x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=4 4x Using Range values for dpr and quality parameters in the same srcset call is also possible: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , dpr : 1 .. 4 , quality : 80 .. 40 ) https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1&amp;quality=80 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2&amp;quality=63 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3&amp;quality=50 3x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=4&amp;quality=40 4x If necessary you can also use lists with explicit values for dpr and quality : Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , dpr : [ 1 , 2 , 3 ] , quality : [ 80 , 75 , 60 ] ) https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1&amp;quality=80 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2&amp;quality=75 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3&amp;quality=60 3x Or even use a specific quality value for all the URLs in the same srcset: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , dpr : [ 1 , 2 , 3 ] , quality : 70 ) https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=1&amp;quality=70 1x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=2&amp;quality=70 2x, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;dpr=3&amp;quality=70 3x Fluid width When a specific sequence of widths is required you can use a Range , Imglab.Sequence , or list for width parameter. When a Range value is used, a sequence with a default size of 16 URLs will be generated inside the specified interval: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 100 .. 2000 ) https://assets.imglab-cdn.net/image.jpeg?width=100 100w, https://assets.imglab-cdn.net/image.jpeg?width=122 122w, https://assets.imglab-cdn.net/image.jpeg?width=149 149w, https://assets.imglab-cdn.net/image.jpeg?width=182 182w, https://assets.imglab-cdn.net/image.jpeg?width=222 222w, https://assets.imglab-cdn.net/image.jpeg?width=271 271w, https://assets.imglab-cdn.net/image.jpeg?width=331 331w, https://assets.imglab-cdn.net/image.jpeg?width=405 405w, https://assets.imglab-cdn.net/image.jpeg?width=494 494w, https://assets.imglab-cdn.net/image.jpeg?width=603 603w, https://assets.imglab-cdn.net/image.jpeg?width=737 737w, https://assets.imglab-cdn.net/image.jpeg?width=900 900w, https://assets.imglab-cdn.net/image.jpeg?width=1099 1099w, https://assets.imglab-cdn.net/image.jpeg?width=1341 1341w, https://assets.imglab-cdn.net/image.jpeg?width=1638 1638w, https://assets.imglab-cdn.net/image.jpeg?width=2000 2000w If required you can specify a Range value for quality parameter too: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 100 .. 2000 , quality : 80 .. 40 ) https://assets.imglab-cdn.net/image.jpeg?width=100&amp;quality=80 100w, https://assets.imglab-cdn.net/image.jpeg?width=122&amp;quality=76 122w, https://assets.imglab-cdn.net/image.jpeg?width=149&amp;quality=73 149w, https://assets.imglab-cdn.net/image.jpeg?width=182&amp;quality=70 182w, https://assets.imglab-cdn.net/image.jpeg?width=222&amp;quality=66 222w, https://assets.imglab-cdn.net/image.jpeg?width=271&amp;quality=63 271w, https://assets.imglab-cdn.net/image.jpeg?width=331&amp;quality=61 331w, https://assets.imglab-cdn.net/image.jpeg?width=405&amp;quality=58 405w, https://assets.imglab-cdn.net/image.jpeg?width=494&amp;quality=55 494w, https://assets.imglab-cdn.net/image.jpeg?width=603&amp;quality=53 603w, https://assets.imglab-cdn.net/image.jpeg?width=737&amp;quality=50 737w, https://assets.imglab-cdn.net/image.jpeg?width=900&amp;quality=48 900w, https://assets.imglab-cdn.net/image.jpeg?width=1099&amp;quality=46 1099w, https://assets.imglab-cdn.net/image.jpeg?width=1341&amp;quality=44 1341w, https://assets.imglab-cdn.net/image.jpeg?width=1638&amp;quality=42 1638w, https://assets.imglab-cdn.net/image.jpeg?width=2000&amp;quality=40 2000w If you want to generate a sequence of numbers for width parameter with a specific number of URLs you can use sequence function helper: # Remember to import Imglab.Sequence before using sequence/3 helper function import Imglab.Sequence # Generating a srcset string with a sequence of 5 URLs between 100 and 2000 pixels for width parameter Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : sequence ( 100 , 2000 , 5 ) ) https://assets.imglab-cdn.net/image.jpeg?width=100 100w, https://assets.imglab-cdn.net/image.jpeg?width=211 211w, https://assets.imglab-cdn.net/image.jpeg?width=447 447w, https://assets.imglab-cdn.net/image.jpeg?width=946 946w, https://assets.imglab-cdn.net/image.jpeg?width=2000 2000w Using a list with specific values will generate URLs only for those widths: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : [ 100 , 300 , 500 ] ) https://assets.imglab-cdn.net/image.jpeg?width=100 100w, https://assets.imglab-cdn.net/image.jpeg?width=300 300w, https://assets.imglab-cdn.net/image.jpeg?width=500 500w It is also possible to specify a list of values for height and quality parameters: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : [ 100 , 300 , 500 ] , height : [ 200 , 400 , 600 ] , quality : [ 75 , 70 , 65 ] ) https://assets.imglab-cdn.net/image.jpeg?width=100&amp;height=200&amp;quality=75 100w, https://assets.imglab-cdn.net/image.jpeg?width=300&amp;height=400&amp;quality=70 300w, https://assets.imglab-cdn.net/image.jpeg?width=500&amp;height=600&amp;quality=65 500w No size When srcset function doesn't have information about the image output size ( width or height parameters are not set) it will generate a default sequence of 16 URLs specifying a width value with an interval between 100 and 8192 pixels: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; ) https://assets.imglab-cdn.net/image.jpeg?width=100 100w, https://assets.imglab-cdn.net/image.jpeg?width=134 134w, https://assets.imglab-cdn.net/image.jpeg?width=180 180w, https://assets.imglab-cdn.net/image.jpeg?width=241 241w, https://assets.imglab-cdn.net/image.jpeg?width=324 324w, https://assets.imglab-cdn.net/image.jpeg?width=434 434w, https://assets.imglab-cdn.net/image.jpeg?width=583 583w, https://assets.imglab-cdn.net/image.jpeg?width=781 781w, https://assets.imglab-cdn.net/image.jpeg?width=1048 1048w, https://assets.imglab-cdn.net/image.jpeg?width=1406 1406w, https://assets.imglab-cdn.net/image.jpeg?width=1886 1886w, https://assets.imglab-cdn.net/image.jpeg?width=2530 2530w, https://assets.imglab-cdn.net/image.jpeg?width=3394 3394w, https://assets.imglab-cdn.net/image.jpeg?width=4553 4553w, https://assets.imglab-cdn.net/image.jpeg?width=6107 6107w, https://assets.imglab-cdn.net/image.jpeg?width=8192 8192w It is always possible to change this default behavior using sequence function helper. In the following example we are specifying a sequence of 10 different URLs between 320 and 4096 pixels: import Imglab.Sequence Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : sequence ( 320 , 4096 , 10 ) ) https://assets.imglab-cdn.net/image.jpeg?width=320 320w, https://assets.imglab-cdn.net/image.jpeg?width=425 425w, https://assets.imglab-cdn.net/image.jpeg?width=564 564w, https://assets.imglab-cdn.net/image.jpeg?width=749 749w, https://assets.imglab-cdn.net/image.jpeg?width=994 994w, https://assets.imglab-cdn.net/image.jpeg?width=1319 1319w, https://assets.imglab-cdn.net/image.jpeg?width=1751 1751w, https://assets.imglab-cdn.net/image.jpeg?width=2324 2324w, https://assets.imglab-cdn.net/image.jpeg?width=3086 3086w, https://assets.imglab-cdn.net/image.jpeg?width=4096 4096w Image aspect ratio and srcset A usual scenario is to generate multiple URLs while maintaining the same aspect ratio for all of them. If a specific image aspect ratio is required while using srcset function you can set a value to aspect-ratio parameter along with mode parameter using crop , contain , face , or force resize modes. For the following example we are using a specific value of 300 pixels for width and an aspect ratio of 1:1 (square), cropping the image with crop resize mode and setting output format to webp : Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 300 , aspect_ratio : &quot;1:1&quot; , mode : :crop , format : :webp ) https://assets.imglab-cdn.net/image.jpeg?width=300&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?width=300&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?width=300&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp&amp;dpr=3 3x, https://assets.imglab-cdn.net/image.jpeg?width=300&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp&amp;dpr=4 4x, https://assets.imglab-cdn.net/image.jpeg?width=300&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp&amp;dpr=5 5x, https://assets.imglab-cdn.net/image.jpeg?width=300&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp&amp;dpr=6 6x You can instead use height value. In this example we are specifying a fixed value of 300 pixels for height parameter, a aspect-ratio of 16:9 (widescreen) with crop resize mode, and webp output format: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , height : 300 , aspect_ratio : &quot;16:9&quot; , mode : :crop , format : :webp ) https://assets.imglab-cdn.net/image.jpeg?height=300&amp;aspect-ratio=16%3A9&amp;mode=crop&amp;format=webp&amp;dpr=1 1x, https://assets.imglab-cdn.net/image.jpeg?height=300&amp;aspect-ratio=16%3A9&amp;mode=crop&amp;format=webp&amp;dpr=2 2x, https://assets.imglab-cdn.net/image.jpeg?height=300&amp;aspect-ratio=16%3A9&amp;mode=crop&amp;format=webp&amp;dpr=3 3x, https://assets.imglab-cdn.net/image.jpeg?height=300&amp;aspect-ratio=16%3A9&amp;mode=crop&amp;format=webp&amp;dpr=4 4x, https://assets.imglab-cdn.net/image.jpeg?height=300&amp;aspect-ratio=16%3A9&amp;mode=crop&amp;format=webp&amp;dpr=5 5x, https://assets.imglab-cdn.net/image.jpeg?height=300&amp;aspect-ratio=16%3A9&amp;mode=crop&amp;format=webp&amp;dpr=6 6x You can also use fluid values for width parameter while maintaining the same aspect ratio for all generated URLs. In this example, we are using a range value between 100 and 4096 for width parameter, a value of 1:1 for aspect-ratio , crop resize mode and webp output format: Imglab . srcset ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 100 .. 4096 , aspect_ratio : &quot;1:1&quot; , mode : :crop , format : :webp ) https://assets.imglab-cdn.net/image.jpeg?width=100&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 100w, https://assets.imglab-cdn.net/image.jpeg?width=128&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 128w, https://assets.imglab-cdn.net/image.jpeg?width=164&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 164w, https://assets.imglab-cdn.net/image.jpeg?width=210&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 210w, https://assets.imglab-cdn.net/image.jpeg?width=269&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 269w, https://assets.imglab-cdn.net/image.jpeg?width=345&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 345w, https://assets.imglab-cdn.net/image.jpeg?width=442&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 442w, https://assets.imglab-cdn.net/image.jpeg?width=566&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 566w, https://assets.imglab-cdn.net/image.jpeg?width=724&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 724w, https://assets.imglab-cdn.net/image.jpeg?width=928&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 928w, https://assets.imglab-cdn.net/image.jpeg?width=1188&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 1188w, https://assets.imglab-cdn.net/image.jpeg?width=1522&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 1522w, https://assets.imglab-cdn.net/image.jpeg?width=1949&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 1949w, https://assets.imglab-cdn.net/image.jpeg?width=2497&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 2497w, https://assets.imglab-cdn.net/image.jpeg?width=3198&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 3198w, https://assets.imglab-cdn.net/image.jpeg?width=4096&amp;aspect-ratio=1%3A1&amp;mode=crop&amp;format=webp 4096w","ref":"readme.html#generating-srcsets","title":"imglab - Generating srcsets","type":"extras"},{"doc":"imglab source code is released under MIT License .","ref":"readme.html#license","title":"imglab - License","type":"extras"},{"doc":"MIT License Copyright (c) 2021 imglab Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]